// Copyright (c) Facebook, Inc. and its affiliates.
//
// This source code is licensed under the MIT license found in the
// LICENSE file in the "hack" directory of this source tree.

pub use std::hash::Hash;
pub use std::hash::Hasher;

pub use no_pos_hash::position_insensitive_hash;

pub fn hash<T: Hash>(value: &T) -> u64 {
    let mut hasher = fnv::FnvHasher::default();
    value.hash(&mut hasher);
    hasher.finish()
}
